import 'dart:async';

import 'dart:io';

import 'filestateprovider.dart';

class FutureRead {
  File _file;
  int _last;
  int _temp;
  int _lastWritten;
  int _written;
  FileStateProvider _sp;
  bool _running = false;
  bool _ran = false;
  bool _closed = false;
  int _end;
  StreamController<List<int>> _c = new StreamController<List<int>>();
  FutureRead(File file, sp, int last, int written, int end) {
    this._file = file;
    this._last = last;
    this._written = written;
    this._sp = sp;
    this._end = end;
    run(Future<dynamic> event) {
      _running = true;
      _ran = true;
      event.then((d) {
        _lastWritten = _written;
        if (_last != _written) {
          run(_c.addStream(_file.openRead(_last, _written)).then((d) {
            _last = _lastWritten;
            return d;
          }));
        } else if (_closed) {
          _c.close();
        } else {
          _last = _lastWritten;
          _running = false;
        }
      });
    }
      if (_last < _written) {
        _temp = _last;
        _last = _written;
        _lastWritten = written;
        run(_c.addStream(_file.openRead(_temp, written)));
      }
      if (_lastWritten != this._end) {
        _sp.until(last, this._end).listen((int write) {
          _written = write;
          if (write == this._end) {
            _closed = true;
          }
          if (!_running) {
            int temp = _last;
            _last = _written;
            run(_c.addStream(_file.openRead(temp, _written),
                cancelOnError: true));
          }
        }, onDone: () {
          _closed = true;
          if (!_ran) {
            _c.close();
          }
        }, onError: (err) {
          _closed = true;
          _c.addError(err);
        });
      } else {
        _closed = true;
      }
  }

  Stream<List<int>> get stream {
    return _c.stream;
  }
}
