import 'dart:convert';

/// Represents the last know state of all JsonTokens
class JsonTokenState {
  Map<int, Map<String, dynamic>> _queue = new Map<int, Map<String, dynamic>>();
  //unclosed objects ids
  //unclosed arrays ids
  List<Map<String, dynamic>> _partners = new List<Map<String, dynamic>>();
  List<Map<String, dynamic>> _parents = new List<Map<String, dynamic>>();
  int _quotes;
  JsonTokenState(
      Map<int, Map<String, dynamic>> queue,
      List<Map<String, dynamic>> partners,
      List<Map<String, dynamic>> parents,
      int quotes) {
    this._queue = queue;
    this._partners = partners;
    this._parents = parents;
    this._quotes = quotes;
  }
  JsonTokenState.empty();

  ///Convert state to string
  String toString() {
    Map<String, dynamic> details = new Map<String, dynamic>();
    details['queue'] = new Map<String, dynamic>();
    _queue.forEach((int key, Map<String, dynamic> value) {
      details['queue'][key.toString()] = value;
    });
    details['partners'] = _partners;
    details['parents'] = _parents;
    details['quotes'] = _quotes;
    return jsonEncode(details);
  }

  ///Convert state to map
  Map<String, dynamic> toMap() {
    Map<String, dynamic> details = new Map<String, dynamic>();
    details['queue'] = new Map<String, dynamic>();
    _queue.forEach((int key, Map<String, dynamic> value) {
      details['queue'][key.toString()] = value;
    });
    details['partners'] = _partners;
    details['parents'] = _parents;
    details['quotes'] = _quotes;
    return details;
  }

  Map<String, dynamic> data() {
    Map<String, dynamic> details = new Map<String, dynamic>();
    details['queue'] = _queue;
    details['partners'] = _partners;
    details['parents'] = _parents;
    details['quotes'] = _quotes;
    return details;
  }

  ///Create JsonTokenState from String
  JsonTokenState.fromString(String details) {
    dynamic decoded = jsonDecode(details);
    decoded['queue'].forEach((String key, dynamic value) {
      _queue[int.parse(key)] = value;
    });
    _partners = new List.from(decoded['partners']);
    _parents = new List.from(decoded['parents']);
    _quotes = decoded['quotes'];
  }

  JsonTokenState fromMap(Map<String, dynamic> decoded) {
    decoded['queue'].forEach((String key, dynamic value) {
      _queue[int.parse(key)] = value;
    });
    _partners = new List.from(decoded['partners']);
    _parents = new List.from(decoded['parents']);
    _quotes = decoded['quotes'];
    return this;
  }
}
